Index: /trunk/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs	(revision 17575)
+++ /trunk/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs	(revision 17576)
@@ -251,5 +251,5 @@
         TaskData taskData = wcfService.GetTaskData(taskId);
         if (taskData == null) throw new TaskDataNotFoundException(taskId);
-        task = wcfService.UpdateJobState(taskId, TaskState.Calculating, null);
+        task = wcfService.UpdateTaskState(taskId, TaskState.Calculating, null);
         if (task == null) throw new TaskNotFoundException(taskId);
         taskManager.StartTaskAsync(task, taskData);
@@ -268,14 +268,14 @@
       }
       catch (OutOfCoresException) {
-        wcfService.UpdateJobState(taskId, TaskState.Waiting, "No more cores available");
+        wcfService.UpdateTaskState(taskId, TaskState.Waiting, "No more cores available");
         throw;
       }
       catch (OutOfMemoryException) {
-        wcfService.UpdateJobState(taskId, TaskState.Waiting, "No more memory available");
+        wcfService.UpdateTaskState(taskId, TaskState.Waiting, "No more memory available");
         throw;
       }
       catch (Exception e) {
         SlaveStatusInfo.DecrementUsedCores(usedCores);
-        wcfService.UpdateJobState(taskId, TaskState.Failed, e.ToString());
+        wcfService.UpdateTaskState(taskId, TaskState.Failed, e.ToString());
         throw;
       }
@@ -391,5 +391,5 @@
           wcfService.UpdateTaskData(task, taskData, configManager.GetClientInfo().Id, TaskState.Failed, exception.ToString());
         } else {
-          wcfService.UpdateJobState(task.Id, TaskState.Failed, exception.ToString());
+          wcfService.UpdateTaskState(task.Id, TaskState.Failed, exception.ToString());
         }
         SlaveClientCom.Instance.LogMessage(exception.Message);
@@ -408,5 +408,5 @@
       var slaveTask = e.Value;
       var task = wcfService.GetTask(slaveTask.TaskId);
-      wcfService.UpdateJobState(task.Id, TaskState.Aborted, null);
+      wcfService.UpdateTaskState(task.Id, TaskState.Aborted, null);
       SlaveStatusInfo.DecrementUsedCores(e.Value.CoresNeeded);
     }
Index: /trunk/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs
===================================================================
--- /trunk/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs	(revision 17575)
+++ /trunk/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs	(revision 17576)
@@ -82,5 +82,5 @@
     }
 
-    public Task UpdateJobState(Guid taskId, TaskState taskState, string exception) {
+    public Task UpdateTaskState(Guid taskId, TaskState taskState, string exception) {
       return CallHiveService(s => s.UpdateTaskState(taskId, taskState, ConfigManager.Instance.GetClientInfo().Id, null, exception));
     }
Index: /trunk/Installers/HiveSlaveInstaller.nsi
===================================================================
--- /trunk/Installers/HiveSlaveInstaller.nsi	(revision 17575)
+++ /trunk/Installers/HiveSlaveInstaller.nsi	(revision 17576)
@@ -46,6 +46,8 @@
 	SetOutPath $INSTDIR
 
+	File "${SLAVEBUILDPATH}\Google.Protobuf.dll"
+	File "${SLAVEBUILDPATH}\HEAL.Attic.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Common-3.3.dll"
 	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe"
-	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Common-3.3.dll"
 	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config"
 	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll"
@@ -82,25 +84,6 @@
 
 	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe" --uninstall'
-	  
-	Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe
-	Delete $INSTDIR\HeuristicLab.Clients.Common-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config
-	Delete $INSTDIR\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Clients.Hive-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Collections-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Common.Resources-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Common-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Core-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Data-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Hive-3.3.dll
-	Delete $INSTDIR\HeuristicLab.MainForm-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Optimization-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Parameters-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Persistence-3.3.dll
-	Delete $INSTDIR\HeuristicLab.PluginInfrastructure-3.3.dll
-	Delete $INSTDIR\HeuristicLab.Tracing-3.3.dll
-	Delete $INSTDIR\uninstall.exe
 
-	RMDir "$INSTDIR"
+	RMDir /r "$INSTDIR"
 SectionEnd
 